<?php
    // namespace cpay\includes;
/**
 * Fired during plugin activation
 *
 * @link       http://www.centralpay.eu
 * @since      1.0.0
 *
 * @package    cpay
 * @subpackage cpay/includes
 */

/**
 * Fired during plugin activation.
 *
 * This class defines all code necessary to run during the plugin's activation.
 *
 * @since      1.0.0
 * @package    cpay
 * @subpackage cpay/includes
 * @author     Central Pay
 */
class CpayActivator
{


    /**
     * Intialize this class
     * @since    1.0.0
     */
    public function __construct()
    {
          //table not in database. Create new table
    }

    /**
     * Short Description. (use period)
     *
     * Long Description.
     *
     * @since    1.0.0
     */
    public static function activate()
    {
        Self::createCpayTables();
    }

    /**
     * Create the centralPay data tables
     *
     * @since    1.0.0
     */
    private static function createCpayTables()
    {
        global $wpdb;


        $table_cpay_card = $wpdb->prefix. 'woocommerce_cpay_card';
        $table_cpay_customer = $wpdb->prefix. 'woocommerce_cpay_customer';

        if ($wpdb->get_var("SHOW TABLES LIKE '" . $table_cpay_card . "'") != $table_cpay_card
                && $wpdb->get_var("SHOW TABLES LIKE '" . $table_cpay_customer . "'") != $table_cpay_customer)
        {

            $req_cpay_card =  "CREATE TABLE `".$table_cpay_card."` (
                                        `customerId` varchar(255) NOT NULL,
                                        `cardId` varchar(36) NOT NULL,
                                        `commercialBrand` varchar(45) DEFAULT NULL,
                                        `first6` varchar(6) DEFAULT NULL,
                                        `last4` varchar(4) DEFAULT NULL,
                                        `default` tinyint(1) DEFAULT NULL,
                                        `creationDate` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP,
                                        `cardTokenId` varchar(255) DEFAULT NULL,
                                        `deleted` tinyint(1) DEFAULT NULL,
                                        `expirationYear` int(11) DEFAULT NULL,
                                        `expirationMonth` int(11) DEFAULT NULL
                                        ) ENGINE=MyISAM DEFAULT CHARSET=latin1;";

            $req_cpay_customer = "CREATE TABLE `".$table_cpay_customer."` (
                                            `cpayCustomerId` varchar(255) NOT NULL,
                                            `wpUserId` int(11) NOT NULL,
                                            `dateCreation` datetime NOT NULL DEFAULT CURRENT_TIMESTAMP
                                            ) ENGINE=MyISAM DEFAULT CHARSET=latin1;";

             $sql = $req_cpay_card . $req_cpay_customer;

             require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
             dbDelta( $sql );

            dbDelta( $sql );
        }
    }
}
