<?php

require_once("../../../../wp-load.php");

if (! class_exists( 'DB' )) {
            require plugin_dir_path( __FILE__ ) . 'class-cpay-wp-db.php';
}
        
if (isset($_GET['card']) || isset($_GET['action']) || isset($_GET['dbname']) || isset($_GET['isdefault'])) {
    if ($_GET['action'] === 'delete') {
        CpayManagedCard::deleteCard($_GET['card'], $_GET['dbname']);
    } elseif ($_GET['action'] === 'default') {
        CpayManagedCard::defaultCard($_GET['card'], $_GET['dbname']);
    }
} else {
    throw new Exception("An error are occurred when the action delete or default, one of the arguments below do not exist : action or cardId.");
}

/**
 * This class allow you to manage the wordpress card.
 */
class CpayManagedCard
{

    /**
     * This function allow you to delete a card in the wordpress site data base.
     *
     * @param int $cardId
     * @return void
     */
    public static function deleteCard($cardId, $dbname)
    {
        if (!isset($cardId) or !isset($dbname)) {
            throw new Exception("An error has occurred  Une erreur est survenue lors de la suppression d'une carte de crédit.");
        } else {
            try {
                DB::deleteCard($cardId, $dbname);
            } catch (Exception $e) {
                throw new Exception($e->getMessage());
            }
        }
    }

/**
 * This function allow you to apply a card as a default payment card.
 *
 * @param int $cardId
 * @return void
 */
    public static function defaultCard($cardId, $dbname)
    {
        if (!isset($cardId) or !isset($dbname)) {
            throw new Exception("Une erreur est survenue lors de la sélection de la carte de paiement par défaut, l'un des paramètres est inexistant.");
        } else {
            try {
                // var_dump($default);die();
                DB::setDefaultCard($cardId, $dbname);
            } catch (Exception $e) {
                throw new Exception($e->getMessage());
            }
        }
    }
}
