<?php
if (! function_exists('processPayment3ds')) {
    require_once("../../../../wp-load.php");

    if (! class_exists( 'CpayConfig' )) {
        require plugin_dir_path( __FILE__ ) . 'class-cpay-config.php';
    }

    /**
     * Allow you to process your payment
     *
     * @return void
     */
    function processPayment3ds()
    {
        try {
            // 1. Get the session
            if (! session_id()) {
                ini_set('session.cookie_samesite', 'None');
                ini_set('session.cookie_secure', true);
                @ session_start();
            }
            if (isset($_SESSION['wcpayment'])) {
                $paRes = $_POST['PaRes'];
                $paymentData = $_SESSION['wcpayment']['paymentData'];
                // Initialize the post vars for the transaciton with session informations
                $postvars = array(
                    'currency' =>  $_SESSION['wcpayment']['currency'],
                    'amount' =>  $_SESSION['wcpayment']['amount'],
                    'endUserIp' =>  $_SESSION['wcpayment']['endUserIp'],
                    '3ds[paRes]' => $paRes,
                    'merchantTransactionId' => $paymentData['merchantTransactionId'],
                    'pointOfSaleId' => $paymentData['pointOfSaleId'],
                    'browserUserAgent' => $paymentData['browserUserAgent'],
                    'browserAcceptLanguage'=> $paymentData['browserAcceptLanguage'],
                    'endUserLanguage'=>$paymentData['endUserLanguage'],
                    'order[country]'=>$paymentData['billing_country'],
                    'order[firstName]'=>$paymentData['firstName'],
                    'order[lastName]'=>$paymentData['lastName'],
                );

                if($_SESSION['wcpayment']['isConnected']){
                    if($_SESSION['wcpayment']['isSelectedCard']){
                        $postvars['customerId'] =  $_SESSION['wcpayment']['customerId'];
                        $postvars['cardId'] =  $_SESSION['wcpayment']['cardId'];
                    }else{
                        if($_SESSION['wcpayment']['isSavedCard']){
                            $postvars['customerId'] =  $_SESSION['wcpayment']['customerId'];
                            $postvars['cardId'] =  $_SESSION['wcpayment']['cardId'];
                        }else{
                            $postvars['customerId'] =  $_SESSION['wcpayment']['customerId'];
                            $postvars['cardId'] =  $_SESSION['wcpayment']['cardId'];
                            $postvars['receiptEmail'] = $paymentData['holderEmail'];
                        }
                    }
                }else{
                    $postvars['cardTokenId'] =  $_SESSION['wcpayment']['cardTokenId'];
                    $postvars['receiptEmail'] = $paymentData['holderEmail'];
                }

                $urlApi = CpayConfig::CPAY_API_PROD_TRANSACTION_URI;
                if (isset($_SESSION['wcpayment']['testmode']) && $_SESSION['wcpayment']['testmode']) {
                    $urlApi = CpayConfig::CPAY_API_TEST_TRANSACTION_URI;
                }

                // Set the default values for curl post transaction
                $defaults = array(
                    // CURLOPT_URL => "https://test-api.centralpay.net/v2/rest/transaction",
                    CURLOPT_URL => $urlApi,
                    CURLOPT_RETURNTRANSFER => 1,
                    CURLOPT_POSTFIELDS => http_build_query($postvars),
                    CURLOPT_POST => 1,
                    CURLOPT_SSL_VERIFYPEER => false,
                    CURLOPT_HEADER => 1,
                    CURLOPT_USERPWD => $_SESSION['wcpayment']['userPassword']
                );


                // CUrl transaction
                $curl = curl_init();
                curl_setopt_array($curl, $defaults);

                $result = curl_exec($curl);

                // Get http response info
                $info = curl_getinfo($curl);
                $header_size = curl_getinfo($curl, CURLINFO_HEADER_SIZE);

                curl_close($curl);

                if (empty($info['http_code'])) {
                    die("No HTTP code was returned");
                }

                $body = substr($result, $header_size);
                $url = plugin_dir_url(__FILE__);
                $errorPage = $url."class-cpay-errorForm.php". "?error=" . $info['http_code'] . "&paymentPageUrl=" . $_SESSION['wcpayment']['paymentPageUrl'];
                $order = new WC_Order(  $_SESSION['wcpayment']['orderId'] );
                // Conditionnal response actions
                switch ($info['http_code']){
                    case 200:
                        $items = $order->get_items();
                        $nbOrderItems = count($items);
                        $nbDownloadableItems = 0 ;
                        foreach($items as $item)
                        {
                            $product = $item->get_product();
                            $productSimple = $product->is_type('simple');
                            $productDownloadable = $product->is_downloadable();
                            if($productSimple && $productDownloadable)
                            {
                                $nbDownloadableItems ++;
                            }
                        }

                        if( $nbDownloadableItems === $nbOrderItems )
                        {
                            $orderStatus ='completed';
                        }
                        else{
                            $orderStatus = 'processing';
                        }
                        $order->update_status( $orderStatus );
                        header("Location: " . $_SESSION['wcpayment']['redirectUrl'] ."");
                        wc_reduce_stock_levels($_SESSION['wcpayment']['orderId']);
                        break;
                    case 402:
                        $order->update_status( 'failed' );
                        header("Location: " . $errorPage);
                        break;
                    default:
                        $order->update_status( 'failed' );
                        header("Location: " . $errorPage);
                        break;
                }

                exit;
            }
        } catch (Exception $e) {
            echo $e->getMessage();
        }
    }

    processPayment3ds();
}
