var urlCentralpayJs = '';
var urlCentralpayApi = '';

jQuery( function( $ ) {
    'use strict';

    var wc_cpay_form = {

        currentForm: null,
        fieldSelectedCard: null,
        merchantPublicKey: null,
        form: null,
        init: function () {
            // checkout page
            if ( $( 'form.woocommerce-checkout' ).length ) {
                this.form = $( 'form.woocommerce-checkout' );
            }

            $( 'form.woocommerce-checkout' )
                .on(
                    'checkout_place_order_cpay',
                    this.onSubmit
                );

            // pay order page
            if ( $( 'form#order_review' ).length ) {
                this.form = $( 'form#order_review' );
                $(this.form).attr('enctype', 'multipart/form-data');
                $(this.form).attr('novalidate', 'novalidate');
                $(this.form).attr('name', 'checkout');
                //$(this.form).addClass('checkout woocommerce-checkout');
            }

            $( 'form#order_review' )
                .on(
                    'submit',
                    wc_cpay_form.onSubmit
                );


            //this.form.on('checkout_place_order_cpay', wc_cpay_form.onSubmit);
            urlCentralpayApi = $('input[name=apiUrl]').val();
            urlCentralpayJs = $('input[name=jsUrl]').val();
            //addScript(urlCentralpayJs+'/js/validation.js');
        },
        onSubmit: function (e){
            e.preventDefault();
            wc_cpay_form.currentForm = document.querySelector('fieldset[data-centralpay="form"]');
            wc_cpay_form.merchantPublicKey = $('input[name="merchantPublicKey"]').val();

            //Prevent other event listener
            Centralpay.utils.safePreventEvent(e);

            if(!wc_cpay_form.isSelectedCard()){
                if(wc_cpay_form.inputValidations() === true){
                    wc_cpay_form.createToken();
                }else{
                    return false;
                }
                if(wc_cpay_form.hasToken()){
                    if($(wc_cpay_form.form).attr('id') === 'order_review'){
                        $(wc_cpay_form.form).off('submit', this.onSubmit);
                    }else{

                        $(wc_cpay_form.form).off('checkout_place_order_cpay', this.onSubmit);
                    }

                    // 2. Envoyer le formulaire principale
                    $(wc_cpay_form.form).submit();
                }
            }else{
                if(wc_cpay_form.customerValidations()){
                    if($(wc_cpay_form.form).attr('id') === 'order_review'){
                        $(wc_cpay_form.form).off('submit', this.onSubmit);
                    }else{

                        $(wc_cpay_form.form).off('checkout_place_order_cpay', this.onSubmit);
                    }

                    // 2. Envoyer le formulaire principale

                    $(wc_cpay_form.form).submit();
                }
            }


            return false;
        },
        isSelectedCard: function(){
            var fieldSelectedCard = document.getElementById('payment_method_cpay_authenticated');
            // Force change value for pass this value to the payment gateway
            if (fieldSelectedCard.checked == false) {
                fieldSelectedCard.value = false;
                return false;
            }else{
                fieldSelectedCard.value = true;
                return true;
            }
        },
        createToken: function(){
            $.ajax({
                url: urlCentralpayApi + 'cardToken',
                type: 'POST',
                data: wc_cpay_form.buildUriQuery(),
                async: false,
                success: function (response) {
                    // Insert cardTokenId in the form
                    $("input[name=cardTokenId]").val(response.cardTokenId);
                    $("input[name=first6]").val(response.card.first6);
                    $("input[name=last4]").val(response.card.last4);
                    $("input[name=cardId]").val(response.card.cardId);
                },
                error: function (e) {
                    var response = e.responseJSON
                    if (response && response.errors) { // Bad Request with json response errors
                        for (var key in response.errors) {
                            $("#customError").append('<li style="color:red;">'+response.errors[key]+'</li>');
                        };
                    }
                }
            });
        },
        buildUriQuery: function () {
            var field = '';
            var query = 'merchantPublicKey=' + $('input[name=merchantPublicKey]').val();
            var centralpayElements = wc_cpay_form.currentForm.querySelectorAll('[data-centralpay]');

            try {

                if (centralpayElements == null) {
                    throw new Exception("An error was occurred when you have try to get element with data-centralpay for build your centralpay request on the api.");
                } else {
                    for (var i = centralpayElements.length - 1; i >= 0; i--) {
                        field = centralpayElements[i];

                        if (field.hasAttribute('data-centralpay') && field.getAttribute('data-centralpay') != "errors") {

                            // Faire split si field is expiration
                            if (field.getAttribute('data-centralpay') == "expiration") {

                                var expirationTab = field.value.split(" / ");

                                query += '&card[expirationMonth]=' +
                                    encodeURIComponent(expirationTab[0]) +
                                    '&card[expirationYear]=' +
                                    encodeURIComponent(expirationTab[1]);

                            } else {
                                query += '&' + field.getAttribute('data-centralpay') + "=" + encodeURIComponent(field.value).replace(/%20/g, '+');
                            }
                        }
                    }
                }

            } catch (e) {
                throw new Exception("An error was occured.");
            }

            return query;
        },
        hasToken : function () {
            if($("input[name='cardTokenId']").val().length > 0){
                return true;
            }
            return false;
        },
        displayErrorMessage: function (field) {
            if (!field) {
                return;
            } else {
                var attributeName = field.getAttribute('data-centralpay').replace('card[', '').replace(']', '');
                var errorMessage = document.getElementById(attributeName + 'ErrorMessage');
                if (!errorMessage) {
                    $('#' + attributeName).after('<p id="' + attributeName + 'ErrorMessage" class="cpayFormErrors" style="color:red;">Fields ' + attributeName + ' is on error.</p>');
                }
            }
        },
        hideErrorMessage: function (field) {
            if (!field) {
                return;
            } else {
                var attributeName = field.getAttribute('data-centralpay').replace('card[', '').replace(']', '');
                var errorMessage = document.getElementById(attributeName + 'ErrorMessage');
                if (errorMessage) {
                    errorMessage.parentNode.removeChild(errorMessage);
                }
            }
        },
        inputValidations: function () {
            var inputIsValid = true;

            var cardNumber = document.querySelector('[data-centralpay="card[number]"]');
            if (!Centralpay.card.validateCardNumber(cardNumber.value.replace(' ', ''))) {
                inputIsValid = false;
                wc_cpay_form.displayErrorMessage(cardNumber);
            } else {
                wc_cpay_form.hideErrorMessage(cardNumber);
            }

            var expiration = document.querySelector('[data-centralpay="expiration"]');
            var expirationsTab = expiration.value.split(' / ');
            if (!Centralpay.card.validateExpirationDate(expirationsTab[0], expirationsTab[1])) {
                inputIsValid = false;
                wc_cpay_form.displayErrorMessage(expiration);
            } else {
                wc_cpay_form.hideErrorMessage(expiration);
            }

            var cvc = document.querySelector('[data-centralpay="card[cvc]"]');
            if (!Centralpay.card.validateCvc(cardNumber.value, cvc.value)) {
                inputIsValid = false;
                wc_cpay_form.displayErrorMessage(cvc);
            } else {
                wc_cpay_form.hideErrorMessage(cvc);
            }

            var holderEmail = document.querySelector('[data-centralpay="card[holderEmail]"]');
            if (!Centralpay.card.validateCardholderEmail(holderEmail.value) || (!holderEmail.value) || (holderEmail.value == ' ')) {
                inputIsValid = false;
                wc_cpay_form.displayErrorMessage(holderEmail);
            } else {
                wc_cpay_form.hideErrorMessage(holderEmail);
            }

            var holderName = document.querySelector('[data-centralpay="card[holderName]"]');
            if (!Centralpay.card.validateCardholderName(holderName.value) || (!holderName.value) || (holderName.value == ' ')) {
                inputIsValid = false;
                wc_cpay_form.displayErrorMessage(holderName);
            } else {
                wc_cpay_form.hideErrorMessage(holderName);
            }

            return inputIsValid;
        },
        customerValidations: function(){
            var field = document.getElementById('customerValidationValue');
            if (field.value) {
                var errorMessage = document.getElementById('CustomerValidationValueErrorMessage');
                if (errorMessage) {
                    errorMessage.parentNode.removeChild(errorMessage);
                }
                return true;
            } else {
                var errorMessage = document.getElementById('CustomerValidationValueErrorMessage');
                if (!errorMessage) {
                    jQuery('#customerValidationValue').after('<p id="CustomerValidationValueErrorMessage" class="cpayFormErrors" style="color:red;">Fields cvc is required.</p>');
                }
                return false;
            }
        }
    };

    wc_cpay_form.init();
});

//function qui permet d'ajouter dynamiquement des scripts JS dans le document
function addScript(src) {
    var script = document.createElement('script');
    script.src = src;
    script.async = false;
    script.charset = "utf-8";
    document.getElementsByTagName("head")[0].appendChild(script);
}

function onChangeRadio() {

    // Input elements
    var payment_method_cpay_guest = document.getElementById('payment_method_cpay_guest');

    // div elements
    var payment_box_withCard = document.getElementById('payment_box_withCard');
    var payment_box_withoutCard = document.getElementById('payment_box_withoutCard');

    var payment_box_withCard_Label = document.getElementById('payment_box_withCard_Label');

    // Checkout button
    var form = jQuery('form.woocommerce-checkout');

    if (payment_method_cpay_guest.checked == false) {

        if (payment_box_withCard) {
            payment_box_withCard.style.display = "initial";
        }
        if (payment_box_withCard_Label) {
            payment_box_withCard_Label.style.display = "initial";
        }
        payment_box_withoutCard.style.display = "none";

        // Désactiver la création du token lors du paiement de la commande en mode authentifié avec un customer centralpay
        //form.off('checkout_place_order_cpay', wc_cpay_form.onSubmit);

    } else if (payment_method_cpay_guest.checked == true) {

        if (payment_box_withCard) {
            payment_box_withCard.style.display = "none";
        }
        if (payment_box_withCard_Label) {
            payment_box_withCard_Label.style.display = "none";
        }
        payment_box_withoutCard.style.display = "initial";

        // Activer la création du token lors du paiement de la commande.
        //form.on('checkout_place_order_cpay', wc_cpay_form.onSubmit);

    }
}

